function a = kmeans(hyper) 

% KMEANS k-means clustering object
%
% A=KMEANS(H) returns a k-means clustering object
% initialized with hyperparameters H.
%
% Hyperparameters and their defaults:
%   k=2              -- the number of clusters
%   a.child=distance -- distance measure to use (a distance object)
%
% Model:
%   mu               -- cluster centers
%
% Methods:
%   training: cluster a dataset
%   testing:  assign points to clusters according to the nearest
%             cluster center
%   distortion: get value of distortion
  
  a.k=2;
  a.child=distance;
  a.mu=[];
  a.distortion=0;

  p = algorithm('kmeans');
  a = class(a,'kmeans',p);
  
  if nargin==1,
    eval_hyper;
  end;
