function a = mc_svm(hyper) 
   
% MC_SVM mc_svm object
% 
% A=MC_SVM(H) returns an mc_svm object initialized with hyperparameters H. 
%
%  Multi-class Support Vector Machine, solving a single
%  optimization problem.
%
% Hyperparameters, and their defaults
%  C=Inf                -- the soft margin C parameter
%  child=kernel         -- the kernel is stored as a member called "child"
% 
% Model
%  alpha                -- the weights
%  b0                   -- the threshold
%  Xsv                  -- the Support Vectors
%
% Methods:
%  train, test, get_w  
  
  
  a.C=Inf;
  a.child=kernel;
 
  % model 
  a.alpha=[];
  a.b0=0;
  a.Xsv=[];
  
  p=algorithm('mc_svm');
  a= class(a,'mc_svm',p);
  
 if nargin==1,
   eval_hyper;
 end;
 
