function [results,a] =  training(sa0,d)
       
  disp(['training ' get_name(sa0) '.... '])
  results=d;
  a=sa0;
  
  
p= length(a.params);

T=a.StartTemperature;
N=a.MaxIterationPerCooling;
r=a.Cooling_schedule;


x0=getX(a.child,a.params)

Eold=evalfunction(a.child,d,a.params,x0,a.loss);
s=1;
Eall=[];

x=x0;

while(s>0)
    s=0;
    rand('state',sum(100*clock));
    % iterate until max per cooling
    R=rand(N,3);
    
    for k=1:N
        % select a random number from uniform distribution  
        u1=R(k,1)
        
        for i=1:p
            if u1 < i/p
                domain=a.paramdomain{i};
                
                x{i}= x0{i}+ 1/2*(domain(2)-domain(1))*(R(k,3)-0.5);
                if x{i}> domain(2) 
                    x{i}=domain(1)+(domain(2)-domain(1))*R(k,3);
                end
                if x{i}< domain(1) 
                    x{i}=domain(1)+(domain(2)-domain(1))*R(k,3);
                end
                
                u1=2;
            end
        end
        
        Enew=evalfunction(a.child,d,a.params,x,a.loss);
        
        [Eold,Enew]

        u2=R(k,2);
        del=Enew-Eold;
        crit=exp(-del/T);
        if(u2<=crit)
             x0=x
 %           Eold=evalfunction(a.child,d,a.params,x0,a.loss);
            Eold=Enew;            
            Eall=[Eall;Eold];
            clf;
            hold on;
            plot(Eall);
            s=s+1;
        end
      pause(1);
      
    end
    T=r*T;
end
x=x0;

a.model=a.child;
a.model=assignParams(a.model,a.params,x);
%x=x0;




% ===============================================
% ===============================================
% train algorithm for actual parameters and 
% return crossvalidation error
% ===============================================
% ===============================================
function x=getX(alg,params)
x=[];
for i=1:length(params)
    x{i}=eval(['alg.',params{i}]);
end



% ===============================================
% ===============================================
% train algorithm for actual parameters and 
% return crossvalidation error
% ===============================================
% ===============================================
function [yval,yvariance]=evalfunction(alg,dat,params,paramvalue,lossfunc)
 y=[];
 alg=assignParams(alg,params,paramvalue)
 [r,a]=train(cv(alg,'folds=2'),dat);
 r=get_mean(r,lossfunc);
 yval=r.child{1}.Y;
 yvariance=yval(2);
 yval=yval(1);

function a=assignParams(alg,params,paramvalue)
 for i=1:length(params)
    if(ischar(paramvalue{i}))
        eval(['alg.',params{i},'=',paramvalue{i}]);
    else
        eval(['alg.',params{i},'=',sprintf('%g',paramvalue{i})]);
    end
end
a=alg;