function d  =  get_track(a,dtrack)
%   get_track returns 
%   d.Y  - outcome of SVM for every point in dtrack.X
%   d.X  - matrix containing in ervery row a.alpha .* Kt
%    Kt=test(a.child,d);  Kt=Kt.X;
%  end

  %% test in batches to avoid generating large kernel matrices
  sz=get_dim(a.Xsv);   %% deal with maximum 500x500 points at a time
  batch_size=round((500^2)/sz);
   
  Yest=[];
  Track =[];
  k=1:size(a.alpha,1);
  for i=[1:batch_size:get_dim(dtrack)]
    
    take= [i:min(i+batch_size-1,get_dim(dtrack))];    
    Kt=get_kernel(a.child,get(dtrack,take),a.Xsv);    
    Yest=[Yest; ((a.alpha'* Kt)+a.b0)'];
    for k=1:size(dtrack.X,1)
        Track=[Track; [a.alpha.*Kt(:,k)]'];
    end
  end
  
  if a.algorithm.use_signed_output==1
    Yest=sign(Yest);
  end

  d=data(Track,Yest); 
  d=set_name(d,[get_name(d) ' -> ' get_name(a)]); 
 