function data_square_plot(a,area,s,d)
% plots a surface plot of an svm which uses !!2!!! dimensional inputs.
% Draws decision line red.
% Usage :  plot(a,[ xmin xmax ymin ymax],step);
%
% Arguments 
% area -  specify the area which you'd like plotted.
%
% optional s    -  the granularity of the area to be plotted... 
%                  low numbers introduce artefacts. Default = 50
%
% You may change the used colormap afterwards.
% Note that the -1000 on the colorbar denotes the decision line.
% Example :  
% d=gen(spiral({'n=3','m=100'}));
% [r s0]=train(svm(kernel('rbf',1)),d)
% plot(s0,[ -20 20 -20 20]);

if(nargin==2)
    s=100;
end
if(isempty(s))
    s=100;
end    
clf;

min_x=area(1);
max_x=area(2);
min_y=area(3);
max_y=area(4);

mx=zeros(s*s,2);
for i=1:s-1
 for j=1:s-1
   mx((i-1)*s+j,:)= [min_x+(i-1)*(max_x-min_x)/s min_y+(j-1)*(max_y-min_y)/s ] ;
  end
end


temp=zeros(s,s);

sflag=a.algorithm.use_signed_output;
a.algorithm.use_signed_output=0;

rx=test(a,data(mx));
rx=sign(get_x(rx)).*sqrt(abs(get_x(rx)));


for i=1:s
 for j=1:s
  temp(i,j)= rx( (i-1)*s+j);
  end
end
hold on;
surf(1:s,1:s,temp'-1000);
view(2);
shading interp;

[c,h]=contour(1:s,1:s,temp',[0 0],'r');
   clabel(c,h);
colorbar

if( exist('d'))
    for i=1:length(d.X(:,1))
        if d.Y(i,1) > 0
            plot3( s+s*(min_x+d.X(i,1))/(max_x-min_x) ,s+s*(min_y+d.X(i,2))/(max_y-min_y),-100,'rx');
        else
            plot3( s+s*(min_x+d.X(i,1))/(max_x-min_x) ,s+s*(min_y+d.X(i,2))/(max_y-min_y),-100,'go');
        end
    end
end

a0.algorithm.use_signed_output=sflag;

colormap gray;

hold off;