function a = kmp(c,hyper) 
  
% kmp spider object
%   
% A=kmp(C,H) returns a greedy kernel matching pursuit wich performs backfitting 
%  object initialized with hyperparameters H and basic TRAINED algorithm c. 
%
% 
%  Hyperparameters, and their defaults
%
%   N=5; 	         -- number of final basis functions
%  Model
%
%   child 		 -- all generated algorithms 
%   original;        	 -- the original TRAINED sv(c/r)-algorithm (!rbf kernels!)
% 
%  Methods:
%
%   train, test, get_w 

  % hyperparams 
  a.N=5;

	  
  
  a.alpha=[];
  
  a.original=c;
  a.original.b0=0;
  
  a.child=[];

  
  p=algorithm('kmp');
  a= class(a,'kmp',p);
 
  a.algorithm.alias={'child','N'}; % 
 
  if nargin==2,
    eval_hyper;
  end;

