function a = rsvm(c,hyper) 
  
% RSVM spider object
%   
% A=RSVM(a,H) returns a reduced support vector object initialized with hyperparameters H. 
%	actually only for gaussian kernels are supported.
%
% 
%  Hyperparameters, and their defaults
%
%   N=5; 	         -- number of final basis functions
%  Model
%
%   original;        	 -- the original TRAINED sv(c/r)-algorithm (!rbf kernels!)
%   child;		 -- the reduced algorithms
% 
%  Methods:
%
%   train, test, get_w 

  % hyperparams 
  a.N=5;

  a.original=c;
  
  a.child=[];
  
  a.optimizer='gaussian_iteration';

  p=algorithm('rsvm');
  a= class(a,'rsvm',p);
 
  a.algorithm.alias={'child','N'}; % 
 
  if nargin==2,  
    eval_hyper;
  end;
