function [RSVs , Betas, ZINIT]=sequentialrsvm(a,Alphas,SVs,Gamma, M);

% SVs: NxD matrix
% Alphas: Nx1 matrix
% Gamma: Gaussian Kernel Paramterers
% M: number of RSVs to generate
% RSVs: MxD (M << N)
% Betas: MxM matrix lower triangular

[Nx D]=size(SVs);
ALPHAS=Alphas;
RSVs=zeros(M,D);
Betas=zeros(M,M);
X=SVs;
reset=0;
ZINIT=[];

for i=1:M

    while reset==0
        [RSVs(i,:) reset zinit]=gaussianiteration(a,X,ALPHAS,Gamma);
        
        if reset==0
        disp(['resetting.. on ' sprintf('%d',i) ' step']);
        end
    end
    
    ZINIT=[ZINIT ; zinit];
    reset=0;

    Betas(i,1:i)=getoptimalcoef(a,SVs,Alphas,RSVs(1:i,:),Gamma);
    ALPHAS=[Alphas ; -1.0*Betas(i,1:i)'];
    X=[SVs ; RSVs(1:i,:)];
end
